栏目分类:
子分类:
返回
名师互学网用户登录
快速导航关闭
当前搜索
当前分类
子分类
实用工具
热门搜索
名师互学网 > IT > 软件开发 > 后端开发 > C/C++/C#

Codeforces Round #809 (Div. 2) 。C. Qpwoeirut And The City

C/C++/C# 更新时间: 发布时间: IT归档 最新发布 模块sitemap 名妆网 法律咨询 聚返吧 英语巴士网 伯小乐 网商动力

Codeforces Round #809 (Div. 2) 。C. Qpwoeirut And The City

本题题意:给你n栋楼,cool楼的定义为比它左右两栋的楼层都高,只可以添加楼层,不可以删减,求在建造尽可能多的cool楼的情况下添加的最少楼层。

思路:做晚刚看到这题时,就想到动态规划,但是苦于本人是蒟蒻,想了一个多小时才过了,感觉还是不太熟练。

首先观察题意我们可以知道,当n为奇数时,只有一种情况,就是从2到n-1每隔一个都是cool楼,因此只要枚举加起来需要多盖的楼层即可,当n为偶数时,可能的情况有0 1 0 1 0 0。0 0 1 0 1 0。0 1 0 0 1 0。(1表示是cool楼)。所以我的想法是用一个dp二维数组,dp[i][0]表示第i栋不是cool楼,dp[i][1]表示第i栋是cool楼,通过样例的1 10 11 1 10 11 10 1 举例,我们可以发现

当i为偶数不是cool楼时有两种情况,1.可能第i-1栋是cool楼,2.可能第i-2栋是cool楼,此时我们取较小的即可,所以此时的状态转移方程为:

dp[i][0]=min(dp[i-1][1],dp[i-2][1]);

当i为奇数时,我们可以发现,此时只能是第i-1栋为cool楼,因此此时的状态转移方程为

dp[i][0]=dp[i-1][1];

同理

当i为偶数时,如果第i栋为cool楼,第i-2栋一定也是cool楼,如果不理解,大家可以通过样例测试。我们设u等于第i栋两边楼层较高的那层楼,所以此时dp[i][1]等于将i变成cool所需要添加的楼层+第i-2栋为cool楼所需要添加的楼层:

dp[i][1]=max(u-a[i]+1,0)+dp[i-2][1];

当i 为奇数时,如果第i栋为cool楼,此时可能是第i-2栋为cool楼,也可能是第i-3栋为cool楼,我们取较小值即可,

dp[i][1]=max(u-a[i]+1,0)+min(dp[i-2][1],dp[i-3][1]);

最后附上代码:

#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
using namespace std;
const int N=5050;
using ll=long long;
const int mod=1e9+7;
int main()
{
  	int t;
  	scanf("%d",&t);
  	while(t--)
  	{
	  	int n;
	  	scanf("%d",&n);
	  	int a[n+1]={0};
	  	for(int i=1;i<=n;i++)
	  	{
		  	scanf("%d",&a[i]);
		}
		ll ans=0;
		if(n&1)
		{
			for(int i=2;i 

本蒟蒻第一次发题解,若有错误,欢迎各位指正

转载请注明:文章转载自 www.mshxw.com
本文地址:https://www.mshxw.com/it/1022582.html
我们一直用心在做
关于我们 文章归档 网站地图 联系我们

版权所有 (c)2021-2022 MSHXW.COM

ICP备案号:晋ICP备2021003244-6号